@echo off
::
:: Saver - Automatisierte Datensicherung
::
:: Stefan Bigerl, www.bigerl.de
::
:: 070312 Erste stabile Basisversion
:: 070319 Dateinamen mit Leerzeichen werden untersttzt
:: 070324 HTML Report wird generiert, Versionssuchroutine vereinfacht. %%~ni anstatt suchen/ersetzen mit set
:: 070903 Pfad bei HTML Report ergnzt, UNC Pfade getestet (ok, \\compname > verzeichnis\\\xx > verzeichnis\xx)

set maxver=5
set BackupPath=c:\backup
set CurrentPath=%~dp0

:: Genug *.ver Dateien vorhanden?
IF not exist %CurrentPath%ver\. MD %CurrentPath%ver
for /L %%H IN (1,1,%maxver%) DO (
 IF not exist %CurrentPath%ver\%%H.ver echo empty > %CurrentPath%ver\%%H.ver
)

:: Suche lteste *.ver Datei
for /F %%i in ('dir %CurrentPath%ver\*.ver /b /o-d') do (
 set oldest_ver=%%~ni
)
echo Found oldest saver version: %oldest_ver%

for /F "delims=" %%i in (%CurrentPath%sources.txt) do call :loop "%%i"

:: HTML Bericht
echo ^<HTML^>^<HEAD^>^<TITLE^>Saver ^&Uuml;bersicht^</TITLE^>^<STYLE TYPE="Text/css"^>a { text-decoration: none;} ^</STYLE^>^</HEAD^>^<BODY^> > %CurrentPath%saver_versions.htm
echo ^<TABLE BORDER="0"^>^<TR^>^<TH^>Version^</TH^>^<TH^>Timestamp^</TH^>^</TR^> >> %CurrentPath%saver_versions.htm
for /F %%i in ('dir %CurrentPath%ver\*.ver /b /o-d') do (
 echo ^<TR^>^<TD^>^<A target="_blank" HREF="file:///%BackupPath%\%%~ni"^>%%~ni^</A^>^</TD^>^<TD^> >> %CurrentPath%saver_versions.htm
 type %CurrentPath%ver\%%i >> %CurrentPath%saver_versions.htm
)
echo ^</BODY^> >> %CurrentPath%saver_versions.htm
goto Ende

:loop
echo Saving %1	
IF not exist %1 (
 color cf
 echo Achtung! Quellpfad %1 ungueltig!
 goto :eof
)
set destpath=%1
set destpath=%destpath::\=_%
set destpath=%destpath:"=%
robocopy %1 "%BackupPath%\%oldest_ver%\%destpath%" /mir /np /log+:%CurrentPath%backup_log.txt > nul
echo %date:~6,4%-%date:~3,2%-%date:~0,2%_%time:~0,2%-%time:~3,2%-%time:~6,2%,%time:~9,5% > %CurrentPath%ver\%oldest_ver%.ver

goto :eof

:Ende